Name:		L-function
Version:	1.23
Release:	13%{?dist}
Summary:	C++ L-function class library and command line interface
Group:		Applications/Engineering
License:	GPLv2+
Source0:	http://oto.math.uwaterloo.ca/~mrubinst/L_function_public/CODE/L-1.23.tar.gz
# From sage tarball, lcalc spkg, debian directory
Source1:	lcalc.1
URL:		http://oto.math.uwaterloo.ca/~mrubinst/L_function_public/L.html
BuildRequires:	gmp-devel
BuildRequires:	pari-devel
Patch0:		L-fix-broken-include-of-libc++.diff
# Build with pari 2.7
Patch1:		pari_2.7.patch
# Correct problem with inline functions casting to double with gcc 4.6 or newer
Patch2:		L-1.23-lcalc_to_double.patch
# http://gcc.gnu.org/gcc-4.9/porting_to.html
Patch3:		L-gcc4.9.patch
Patch4:		L-gcc5.patch

%description
C++ L-function class library and command line interface.

%package	devel
Summary:	Development libraries/headers for %{name}
Group:		Development/Libraries
Requires:	%{name}%{?_isa} = %{version}-%{release}

%description	devel
Headers and libraries for development with %{name}.

%prep
%setup -q -n L-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
rm -f .*DS_Store
rm -f include/*.{swap.crap,bak}
rm -f include/.*{DS_Store,.swp}
rm -f src/.*{DS_Store,.swp}

# Make it actually link with the generated library
sed -e 's|/lib/|/%{_lib}/|g' \
 -e "s|^[^#]*LDFLAGS2.*LDFLAGS1.*\$|LDFLAGS2 = \$(LDFLAGS1) $RPM_LD_FLAGS|" \
 -e 's|libLfunction.so|libLfunction.so.%{version}|g' \
 -e 's|\($(CC).*cc\) libLfunction.so.%{version}|\1 -L. -lLfunction|g' \
 -e 's|-Xlinker -rpath .*||;' \
 -e "s|\(DYN_OPTION=shared\)|\1 -Wl,-soname=libLfunction.so.%{version} -lgomp $RPM_LD_FLAGS|" \
 -e 's|#\(OPENMP_FLAG = -fopenmp\)|\1|' \
 -i src/Makefile
sed -i -e 's/\r//' src/example_programs/example.cc
# Upstream tarball comes with a prebuilt library
rm -f src/libLfunction.a

%build
pushd src
    # Create link before library is created
    ln -sf libLfunction.so.%{version} libLfunction.so
    make %{?_smp_mflags}					\
	EXTRA="$RPM_OPT_FLAGS"					\
	PARI_DEFINE="-DINCLUDE_PARI"				\
	LOCATION_PARI_H="%{_includedir}/pari"			\
	LOCATION_PARI_LIBRARY="%{_libdir}"			\
	all
popd
rm -f src/example_programs/example

%install
mkdir -p $RPM_BUILD_ROOT{%{_includedir},%{_libdir},%{_bindir},%{_mandir}/man1}
pushd src
    make INSTALL_DIR="$RPM_BUILD_ROOT%{_prefix}" install
    mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
    pushd example_data_files
	for sample in *; do
	    install -p -m644 $sample $RPM_BUILD_ROOT%{_datadir}/%{name}/$sample
	done
    popd
    install -m644 example_programs/example.cc \
	$RPM_BUILD_ROOT%{_datadir}/%{name}/example.cc
popd
install -p -m644 %{SOURCE1} $RPM_BUILD_ROOT%{_mandir}/man1
ln -sf libLfunction.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libLfunction.so
# Correct permissions
chmod 644 $RPM_BUILD_ROOT%{_includedir}/Lfunction/*.h
# Make install creates include/Lfunction but sagemath wants include/lcalc
pushd $RPM_BUILD_ROOT%{_includedir}
    ln -sf Lfunction lcalc
popd

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%doc CONTRIBUTORS
%doc COPYING
%doc README
%{_bindir}/lcalc
%{_libdir}/libLfunction.so.%{version}
%{_mandir}/man1/*

%files devel
%doc %{_datadir}/%{name}
%{_includedir}/Lfunction
%{_includedir}/lcalc
%{_libdir}/libLfunction.so

%changelog
* Sun Feb  8 2015 pcpa <paulo.cesar.pereira.de.andrade@gmail.com> - 1.23-13
- Correct problems with sagemath build with gcc 5.0.

* Fri Aug 15 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.23-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Fri Jun 06 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.23-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Mon May 26 2014 pcpa <paulo.cesar.pereira.de.andrade@gmail.com> - 1.23-10
- Add Debian patch to rebuild with pari 2.7.
- Add patch to build with gcc 4.9.

* Fri Aug 02 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.23-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.23-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.23-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue Jul 10 2012 Ville Skyttä <ville.skytta@iki.fi> - 1.23-6
- Build with $RPM_OPT_FLAGS and %%{_smp_mflags} (regression in -5).
- Build with $RPM_LD_FLAGS.

* Sun Jul 1 2012 pcpa <paulo.cesar.pereira.de.andrade@gmail.com> - 1.23-5
- Merge with duplicate review request #821195 that had changelog
  + Correct license tag.
  + Install example source code.
  + Add %%post sections for library.
  + Build lcalc with openmp support.
  + Rename to L to match upstream tarball.
  + Add proper documentation to main package.
  + Remove the "see also" section of lcalc.1 as there is no info page.
  + Initial lcalc spec.
- Do not provide %{name}-static as no such library is/was installed.
- Install CONTRIBUTORS as documentation.
- Remove %%defattr usage.

* Sat Apr 21 2012 Peter Robinson <pbrobinson@fedoraproject.org> - 1.23-4
- Fix build failure (since F-11!) 

* Tue Feb 28 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.23-3
- Rebuilt for c++ ABI breakage

* Thu Jan 12 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.23-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Thu Oct 27 2011 Conrad Meyer <konrad@tylerc.org> - 1.23-1
- Bump to latest upstream.

* Mon Feb 07 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Mar 17 2009 Conrad Meyer <konrad@tylerc.org> - 1.2-3
- Add missing BR on pari-devel.

* Sat Mar 14 2009 Conrad Meyer <konrad@tylerc.org> - 1.2-2
- Include headers in -devel subpackage.
- Include PARI support.

* Sat Nov 8 2008 Conrad Meyer <konrad@tylerc.org> - 1.2-1
- Initial package.
